# File tres/tharset.cl
# August 14, 2008
# By Doug Mink, Harvard-Smithsonian Center for Astrophysics

# THARSET -- Set a specific savelength-dispersed ThAr spectrum
#	     to be a local standard for its configuration

procedure tharset (spectrum)

file	spectrum=""	{prompt="ThAr file with dispersion"}

string  specdir=""	{prompt="Directory for spectrum to plot"}
string	comproot="comp"	{prompt="ThAr file root name"}
bool	verbose=yes	{prompt="Print confirmation of file setting (yes or no)"}

begin

    file cfile, cdb, sdb, spec

    spec = spectrum
    tfib1 (spec)
    cfile = comproot // tfib1.apfib // ".ec.fits"
    if (access (cfile))
	delete (cfile)
    copy (spec, cfile)
    cdb = "database/ec" // comproot // tfib1.apfib // ".ec"
    if (access (cdb))
	delete (cdb)
    fileroot (spec)
    sdb = "database/ec" // fileroot.rootname
    copy (sdb, cdb)
    if (verbose)
	print ("THARSET: ",spec," -> ", cfile)
 
end

# Aug  8 2008	New task
