# File tres/Scripts/tresmed.cl
# May 16, 2008
# By Doug Mink, SAO Telescope Data Center

# TRSMED - Use mscred.combine to compute the median of a list of images

procedure trsmed (images, outfile)

string	images=""	{prompt="Images to combine"}
file	outfile=""	{prompt="Output file name"}

bool	deltemp=yes	{prompt="Delete intermediate image files (y or n)"}
bool	verbose=yes	{prompt="Print process progress (y or n)"}

begin

file	templist, imout
string	tchar, imagelist, history, dstring
file	listfile, imfile
bool	dellist, vb

	vb = verbose
	dellist = deltemp
	imagelist = images
	imout = outfile

# Load needed packages if necessary
	if (!defpac ("mscred"))
	    mscred

#  Make temporary list of input files
	templist = mktemp ("tempmed") // ".list"
	files (imagelist, >templist)

	combine.input = "@" // templist
	combine.output = imout
	combine.headers = ""
	combine.bpmasks = ""
	combine.rejmasks = ""
	combine.nrejmasks = ""
	combine.expmasks = ""
	combine.sigmas = ""
	combine.ccdtype = ""
	combine.amps = no
	combine.subsets = no
	combine.delete = no
	combine.combine = "median"
	combine.reject = "ccdclip"
	combine.project = no
	combine.outtype = "real"
	combine.outlimits = ""
	combine.offsets = "none"
	combine.masktype = "none"
	combine.maskvalue = 0.
	combine.blank = 0.
	combine.scale = "exposure"
	combine.zero = "none"
	combine.weight = "none"
	combine.statsec = ""
	combine.lthreshold = INDEF
	combine.hthreshold = INDEF
	combine.nlow = 1
	combine.nhigh = 1
	combine.nkeep = 1
	combine.mclip = yes
	combine.lsigma = 3.
	combine.hsigma = 3.
	combine.rdnoise = "0."
	combine.gain = "1."
	combine.snoise = "0."
	combine.sigscale = 0.1
	combine.pclip = -0.5
	combine.grow = 0.

	combine (imagelist, imout)

# Make history line including time
	gettime (0.0)
	dstring = gettime.date // " " // gettime.time
	history = dstring // " median of images"
	hedit (imout, "TRSMED", history, add+, verify-)

	if (dellist) {
	    if (access (templist))
		delete (templist)
	    }

end

# Dec 14 2007	New program for TRES pipeline

# Jan 10 2008	Change name from tresmed to trsmed
# Jan 31 2008	Add TRSSUM keyword to output header
# Feb 11 2008	Change temporary file from tempcombine*list to tempmed*.list
# May 16 2008	Add input time argument to gettime() 
