# File tres/Scripts/trsgroup.cl
# August 14, 2008
# By Doug Mink

# TRSPROC: Process TRES data from lists of files made by TRSGROUP

procedure trsproc (sproc)

string	sproc="cfto"	{prompt="Process c=cal f=flat t=ThAr o=object spectra"}

string	datedir=""	{prompt="Date for images"}
file	instdir=""	{prompt="Directory containing date directories"}
file	imagedir=""	{prompt="Directory containing images (overrides above)"}
file	datafile="data.db"	{prompt="File for observation database"}
file	sortfile="datasort.db"	{prompt="File for sorted observation database"}
bool	verbose=yes	{prompt="Summarize results (yes or no)"}
bool	debug=no	{prompt="Print file sorting instead of writing files (yes or no)"}

struct *proclist

begin
    file image, listfile
    string filelist
    int ngroups, ncal, nobj, ncomp, nflat
    file objlist, callist, flatlist, complist

# Initialize TRSGROUP
    trsgroup.images = "1-300"
    trsgroup.datedir = datedir
    trsgroup.instdir = instdir
    trsgroup.imagedir = imagedir
    trsgroup.datafile = datafile
    trsgroup.sortfile = sortfile
    trsgroup.verbose = verbose
    trsgroup.debug = debug

# Set list names to those in TRSGROUP
    objlist = trsgroup.objlist
    callist = trsgroup.callist
    flatlist = trsgroup.flatlist
    complist = trsgroup.complist

    nflat = 0
    ncal = 0
    ncomp = 0
    nobj = 0

# Process flat field files from lists
    smatch (smatch, "f")
    if (smatch.found) {
	if (!access (flatlist))
	    trsgroup (image)
	proclist = flatlist
    	while (fscan (proclist,listfile) != EOF) {
	    print ("TRSPROC: Processing files ",listfile," from ",flatlist)
	    filelist = "@" // listfile
	    ftres (filelist)
	    nflat = nflat + 1
	    }
	}

# Process dark and bias files from lists
    smatch (smatch, "c")
    if (smatch.found) {
	if (!access (callist))
	    trsgroup (image,callist=callist,objlist="",flatlist="",complist="")
	proclist = callist
	while (fscan (proclist,listfile) != EOF) {
	    print ("TRSPROC: Processing files ",listfile," from ", callist)
	    filelist = "@" // listfile
	    ftres (filelist)
	    ncal = ncal + 1
	    }
	}

# Process Thorium Argon comparison lamp files from lists
    smatch (smatch, "t")
    if (smatch.found) {
	if (!access (complist))
	    trsgroup (image,complist=complist,callist="",flatlist="",objlist="")
	proclist = complist
	while (fscan (proclist,listfile) != EOF) {
	    print ("TRSPROC: Processing files ",listfile," from ", complist)
	    filelist = "@" // listfile
	    ttres (filelist)
	    ncomp = ncomp + 1
	    }
	}

# Process object and sky files from lists
    smatch (smatch, "o")
    if (smatch.found) {
	if (!access (objlist))
	    trsgroup (image,objlist=objlist,callist="",flatlist="",complist="")
	proclist = objlist
	while (fscan (proclist,listfile) != EOF) {
	    print ("TRSPROC: Processing files ",listfile," from ", objlist)
	    filelist = "@" // listfile
	    ctres (filelist)
	    nobj = nobj + 1
	    }
	}
    
# Summarize the sorting process
    ngroups = nobj + ncal + nflat + ncomp
    if (verbose)
	print ("TRSPROC: ", ngroups, " groups of spectra processed")

    proclist = ""
end

# Jul 31 2008	New task
# Aug 14 2008	Use file names from trsgroup; set type(s) to process from stype
